> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rootly.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a heartbeat

> Update a specific heartbeat by id



## OpenAPI

````yaml https://rootly-heroku.s3.amazonaws.com/swagger/v1/swagger.json put /v1/heartbeats/{id}
openapi: 3.0.1
info:
  title: Rootly API v1
  version: v1
  description: >+
    # How to generate an API Key?

    - **Organization dropdown** > **Organization Settings** > **API Keys**


    # JSON:API Specification

    Rootly is using **JSON:API** (https://jsonapi.org) specification:

    - JSON:API is a specification for how a client should request that resources
    be fetched or modified, and how a server should respond to those requests.

    - JSON:API is designed to minimize both the number of requests and the
    amount of data transmitted between clients and servers. This efficiency is
    achieved without compromising readability, flexibility, or discoverability.

    - JSON:API requires use of the JSON:API media type
    (**application/vnd.api+json**) for exchanging data.


    # Authentication and Requests

    We use standard HTTP Authentication over HTTPS to authorize your requests.

    ```
      curl --request GET \
    --header 'Content-Type: application/vnd.api+json' \

    --header 'Authorization: Bearer YOUR-TOKEN' \

    --url https://api.rootly.com/v1/incidents

    ```


    <br/>


    # Rate limiting

    - There is a default limit of **5** **GET**, **HEAD**, and **OPTIONS** calls
    **per API key** every **60 seconds** (0 hours). The limit is calculated over
    a **0-hour sliding window** looking back from the current time. While the
    limit can be configured to support higher thresholds, you must first contact
    your **Rootly Customer Success Manager** to make any adjustments.

    - There is a default limit of **3** **POST**, **PUT**, **PATCH** or
    **DELETE** calls **per API key** every **60 seconds** (0 hours). The limit
    is calculated over a **0-hour sliding window** looking back from the current
    time. While the limit can be configured to support higher thresholds, you
    must first contact your **Rootly Customer Success Manager** to make any
    adjustments.

    - When rate limits are exceeded, the API will return a **429 Too Many
    Requests** HTTP status code with the response: `{"error": "Rate limit
    exceeded. Try again later."}`

    - **X-RateLimit headers** are included in every API response, providing
    real-time rate limit information:
      - **X-RateLimit-Limit** - The maximum number of requests permitted and the time window (e.g., "1000, 1000;window=3600" for 1000 requests per hour)
      - **X-RateLimit-Remaining** - The number of requests remaining in the current rate limit window
      - **X-RateLimit-Used** - The number of requests already made in the current window
      - **X-RateLimit-Reset** - The time at which the current rate limit window resets, in UTC epoch seconds

    # Pagination

    - Pagination is supported for all endpoints that return a collection of
    items.

    - Pagination is controlled by the **page** query parameter


    ## Example

    ```
      curl --request GET \
    --header 'Content-Type: application/vnd.api+json' \

    --header 'Authorization: Bearer YOUR-TOKEN' \

    --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10

    ```

  x-logo:
    url: https://rootly-heroku.s3.us-east-1.amazonaws.com/swagger/v1/logo.png
servers:
  - url: https://api.rootly.com
security: []
paths:
  /v1/heartbeats/{id}:
    parameters:
      - name: id
        in: path
        schema:
          anyOf:
            - type: string
              format: uuid
              description: Resource UUID
            - type: string
              pattern: ^[a-z0-9_-]+$
              description: Resource slug
        required: true
    put:
      tags:
        - Heartbeats
      summary: Update a heartbeat
      description: Update a specific heartbeat by id
      operationId: updateHeartbeat
      parameters: []
      requestBody:
        content:
          application/vnd.api+json:
            schema:
              $ref: '#/components/schemas/update_heartbeat'
        required: true
      responses:
        '200':
          description: heartbeat updated
          content:
            application/vnd.api+json:
              schema:
                $ref: '#/components/schemas/heartbeat_response'
        '404':
          description: resource not found
          content:
            application/vnd.api+json:
              schema:
                $ref: '#/components/schemas/errors_list'
        '422':
          description: invalid enum value
          content:
            application/vnd.api+json:
              schema:
                $ref: '#/components/schemas/errors_list'
      security:
        - bearer_auth: []
components:
  schemas:
    update_heartbeat:
      type: object
      properties:
        data:
          type: object
          properties:
            type:
              type: string
              enum:
                - heartbeats
            attributes:
              type: object
              properties:
                name:
                  type: string
                  description: The name of the heartbeat
                description:
                  type: string
                  description: The description of the heartbeat
                  nullable: true
                alert_summary:
                  type: string
                  description: Summary of alerts triggered when heartbeat expires.
                alert_description:
                  type: string
                  description: Description of alerts triggered when heartbeat expires.
                  nullable: true
                alert_urgency_id:
                  type: string
                  description: Urgency of alerts triggered when heartbeat expires.
                  nullable: true
                interval:
                  type: integer
                interval_unit:
                  type: string
                  enum:
                    - minutes
                    - hours
                    - days
                notification_target_id:
                  type: string
                notification_target_type:
                  type: string
                  description: >-
                    The type of the notification target. Please contact support
                    if you encounter issues using `Functionality` as a target
                    type.
                  enum:
                    - User
                    - Group
                    - Service
                    - EscalationPolicy
                    - Functionality
                enabled:
                  type: boolean
                  description: Whether to trigger alerts when heartbeat is expired.
              additionalProperties: false
          required:
            - type
            - attributes
      required:
        - data
    heartbeat_response:
      type: object
      properties:
        data:
          type: object
          properties:
            id:
              type: string
              description: Unique ID of the heartbeat
            type:
              type: string
              enum:
                - heartbeats
            attributes:
              type: object
              allOf:
                - $ref: '#/components/schemas/heartbeat'
          required:
            - id
            - type
            - attributes
      required:
        - data
    errors_list:
      type: object
      properties:
        errors:
          type: array
          items:
            type: object
            properties:
              title:
                type: string
              status:
                type: string
              code:
                type: string
                nullable: true
              detail:
                type: string
                nullable: true
            required:
              - title
              - status
    heartbeat:
      type: object
      properties:
        name:
          type: string
          description: The name of the heartbeat
        description:
          type: string
          description: The description of the heartbeat
          nullable: true
        alert_summary:
          type: string
          description: Summary of alerts triggered when heartbeat expires.
        alert_description:
          type: string
          description: Description of alerts triggered when heartbeat expires.
          nullable: true
        alert_urgency_id:
          type: string
          description: Urgency of alerts triggered when heartbeat expires.
          nullable: true
        interval:
          type: integer
        interval_unit:
          type: string
          enum:
            - minutes
            - hours
            - days
        notification_target_id:
          type: string
        notification_target_type:
          type: string
          description: >-
            The type of the notification target. Please contact support if you
            encounter issues using `Functionality` as a target type.
          enum:
            - User
            - Group
            - Service
            - EscalationPolicy
            - Functionality
        enabled:
          type: boolean
          description: Whether to trigger alerts when heartbeat is expired.
        status:
          type: string
          enum:
            - waiting
            - active
            - expired
        ping_url:
          type: string
          nullable: true
          description: URL to receive heartbeat pings.
        secret:
          type: string
          nullable: true
          description: Secret used as bearer token when pinging heartbeat.
        email_address:
          type: string
          description: Email address to receive heartbeat pings.
        last_pinged_at:
          type: string
          description: When the heartbeat was last pinged.
          nullable: true
        expires_at:
          type: string
          description: When heartbeat expires
          nullable: true
        created_at:
          type: string
          description: Date of creation
        updated_at:
          type: string
          description: Date of last update
      required:
        - name
        - alert_summary
        - interval
        - interval_unit
        - notification_target_id
        - notification_target_type
        - enabled
        - status
        - email_address
        - created_at
        - updated_at
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer

````